---
title: Developers Demand UX for K8s!
weight: 10
tags:
  - platform
  - dx
---

A talk by UX and software people at Red Hat (Podman team).
The talk mainly followed the academic study process (aka this is the survey I did for my bachelor's/master's thesis).

## Research

* User research Study including 11 devs and platform engineers over three months
* Focus was on a new Podman desktop feature
* Experience range 2-3 years experience average (low no experience, high old school kube)
* 16 questions regarding environment, workflow, debugging and pain points
* Analysis: Affinity mapping

## Findings

* Where do I start when things are broken? -> There may be solutions, but devs don't know about them
* Network debugging is hard b/c many layers and problems occurring in between CNI and infra are really hard -> Network topology issues are rare but hard
* YAML indentation -> Tool support is needed for visualization
* YAML validation -> Just use validation in dev and GitOps
* YAML Cleanup -> Normalize YAML (order, anchors, etc.) for easy diff
* Inadequate security analysis (too verbose, non-issues are warnings) -> Real-time insights (and during dev)
* Crash Loop -> Identify stuck containers, simple debug containers
* CLI vs GUI -> Enable experience level oriented GUI, Enhance in-time troubleshooting

## General issues

* No direct fs access
* Multiple kubeconfigs
* SaaS is sometimes only provided on kube, which sounds like complexity
* Where do I begin my troubleshooting
* Interoperability/Fragility with updates
